Package: metalcor
Title: Meta-Analysis of Correlated Genetic Association Studies
Version: 1.0.0
Authors@R: c(
    person(given = "Alejandro",
	   family = "Ochoa",
	   role = c("aut", "cre"),
	   email = "alejandro.ochoa@duke.edu",
           comment = c(ORCID = "0000-0003-4928-3403")),
    person(given = "Tiffany",
	   family = "Tu",
	   role = c("aut"),
	   email = "tiffany.tu@duke.edu",
           comment = c(ORCID = "0000-0002-9357-6660"))
    )
Description: The main function performs meta-analysis of genetic association study summary statistics that may be correlated due to cryptic relatedness or other confounders, generalizing inverse variance weighted methods.  The function that estimates the correlation structure is also provided standalone.  Another key innovation, the estimation of the correlation parameter from the median product of correlated standard normal variables, is provided, as well as a complete set of functions for their underlying distribution: density, cumulative, quantile, and random deviates.  Described in Tu and Ochoa (2025) <doi:10.1101/2025.05.10.653279>.
License: GPL (>= 3)
Encoding: UTF-8
RoxygenNote: 8.0.0
Suggests: knitr, rmarkdown, testthat (>= 3.0.0)
Imports: stats, dplyr, tibble, tidyselect
Config/testthat/edition: 3
VignetteBuilder: knitr
URL: https://github.com/OchoaLab/metalcor
BugReports: https://github.com/OchoaLab/metalcor/issues
NeedsCompilation: no
Packaged: 2026-05-06 19:25:54 UTC; viiia
Author: Alejandro Ochoa [aut, cre] (ORCID:
    <https://orcid.org/0000-0003-4928-3403>),
  Tiffany Tu [aut] (ORCID: <https://orcid.org/0000-0002-9357-6660>)
Maintainer: Alejandro Ochoa <alejandro.ochoa@duke.edu>
Repository: CRAN
Date/Publication: 2026-05-12 19:00:02 UTC
Built: R 4.5.2; ; 2026-05-12 20:51:29 UTC; unix

# metalcor <img src="man/figures/logo.png" alt="metalcor" align="right" />

`metalcor` generalizes the genetic association study meta-analysis software METAL to model studies with correlated statistics, which arise due to cryptic relatedness between studies.

This package also models the distribution of the product of correlated standard normal variables.
This is crucial for estimating correlation using the median product of z-scores, since in this case the median differs substantially from the mean.
The median provides robustness from the outliers caused by strongly associated loci.

## Installation

You can install the released version of metalcor from [CRAN](https://CRAN.R-project.org) with:
``` r
install.packages("metalcor")
```

Install the latest development version from GitHub:
```R
install.packages("devtools") # if needed
library(devtools)
install_github("OchoaLab/metalcor", build_vignettes = TRUE)
```

You can see the package vignette, which has more detailed documentation, by typing this into your R session:
```R
vignette('metalcor')
```

## Example

First load your summary statistics as data frames or tibbles, in the example below suppose they are stored in the variables `study1`, `study2`, and `study3`.
Then follow this example:

``` r
library(metalcor)
# gather the studies in a list
studies <- list( study1, study2, study3 )
# this performs the meta-analysis modeling covariance!
out <- metalcor( studies )
# this is the meta-analyzed association table
out$assoc
# and this is the estimated study covariance matrix
out$R
```

The above carries out the whole analysis for you, including the estimation of the covariance structure.
If you want to focus on estimating this covariance, and you have isolated your study z-scores into a matrix `Z`, you can use this function, and play with its parameters:
``` r
R <- estimate_R( Z )
```
Under the hood of `estimate_R` there is a whole suite of functions concerning the distribution of the product of two correlated standard normal variables, `prodcor` for short, which calibrated z-scores satisfy under the null hypothesis.
In particular, following the model of base R distributions such as `dnorm` and `dunif`, this package provides `dprodcor`, `pprodcor`, `qprodcor`, and `rprodcor`, which are the density, cumulative, quantile, and random deviate functions, respectively.
Lastly, `rho_from_median` implements the estimator of the correlation parameter given the sample median of the product of z-scores.
All of this is needed so the correlation estimates are robust to outlier z-scores, which correspond to highly associated loci.

## ----include = FALSE----------------------------------------------------------
knitr::opts_chunk$set(
                      collapse = TRUE,
                      comment = "#>",
                      fig.width = 6, fig.height = 4, out.width = "100%"
                  )

## -----------------------------------------------------------------------------
# number of studies
S <- 3
# number of loci
m <- 10000
# this is the true covariance matrix of this simulation
R <- matrix(
    c( 1.0, 0.2, 0.0,
      0.2, 1.0, 0.1,
      0.0, 0.1, 1.0 ),
    nrow = 3, ncol = 3
)

# simulate the correlated Z scores first
# use Cholesky decomposition to simulate via affine transform
L <- chol( R )
Z <- matrix( rnorm( m * 3 ), nrow = m, ncol = 3 ) %*% L

# construct some trivial study summary statistics with the above Z scores
library(tibble)
library(dplyr)
study1 <- tibble(
    id = 1 : m,
    chr = ceiling( id / m * 10 ),
    pos = id,
    n = 1000,
    z = Z[, 1],
    se = runif( m, 0, 1 / sqrt( n ) ),
    beta = z * se
)
# this copies id/chr/pos between studies, adds study-specific info.
# note that, besides the different Z scores, there's also different sample sizes per study,
# and standard errors scale inversely proportional to the square root of study size
study2 <- study1 %>%
    select( id, chr, pos) %>%
    mutate(
        n = 2000,
        z = Z[, 2],
        se = runif( m, 0, 1 / sqrt( n ) ),
        beta = z * se
    )
study3 <- study1 %>%
    select( id, chr, pos) %>%
    mutate(
        n = 10000,
        z = Z[, 3],
        se = runif( m, 0, 1 / sqrt( n ) ),
        beta = z * se
    )
# for realism, randomly subset studies so only 90% of loci survive, different sets per study
study1 <- study1[ sort( sample.int( m, m * 0.9) ), ]
study2 <- study2[ sort( sample.int( m, m * 0.9) ), ]
study3 <- study3[ sort( sample.int( m, m * 0.9) ), ]

## -----------------------------------------------------------------------------
library(metalcor)

# gather studies into a list
studies <- list( study1, study2, study3 )
# pass to metalcor!
out <- metalcor( studies )
# you can quickly inspect the return value, it is a list with two named elements:
# - assoc: the meta-analyzed association table
# - R: the estimated covariance matrix between studies
out

## -----------------------------------------------------------------------------
mean( out$assoc$z^2 )

## -----------------------------------------------------------------------------
# default median estimate
estimate_R( Z )
# mean estimate
estimate_R( Z, median = FALSE )
# standard sample covariance estimate is similar but not identical
cov( Z, use = 'pairwise.complete.obs' )

## -----------------------------------------------------------------------------
n <- 10000
rho <- 0.33

# draw random values from this distribution
x <- rprodcor( n, rho )
x <- sort( x )
# this is the theoretical density function at those points
y <- dprodcor( x, rho )

# compare empirical and theoretical densities
hist( x, breaks = 100, freq = FALSE )
lines( x, y, col = 'red' )

# compare empirical and theoretical CDF now
yc <- pprodcor( x, rho )
plot( ecdf( x ) )
lines( x, yc, lty = 2, col = 'red' )

## -----------------------------------------------------------------------------
x <- ( (-200) : 200 ) / 100
plot( x, dprodcor( x, -1 ), type ='l', col = 'red', ylab = 'Density' )
lines( x, dprodcor( x, -0.5 ), col = 'orange' )
lines( x, dprodcor( x, 0 ), col = 'black' )
lines( x, dprodcor( x, 0.5 ), col = 'green' )
lines( x, dprodcor( x, 1 ), col = 'blue' )
legend(
    'topright',
    legend = c( -1, -0.5, 0, 0.5, 1 ),
    col = c( 'red', 'orange', 'black', 'green', 'blue' ),
    lty = 1,
    title = expression( rho )
)

## -----------------------------------------------------------------------------
plot( x, pprodcor( x, -1 ), type ='l', col = 'red', ylim = c(0,1), ylab = 'CDF' )
lines( x, pprodcor( x, -0.5 ), col = 'orange' )
lines( x, pprodcor( x, 0 ), col = 'black' )
lines( x, pprodcor( x, 0.5 ), col = 'green' )
lines( x, pprodcor( x, 1 ), col = 'blue' )
legend(
    'bottomright',
    legend = c( -1, -0.5, 0, 0.5, 1 ),
    col = c( 'red', 'orange', 'black', 'green', 'blue' ),
    lty = 1,
    title = expression( rho )
)

## -----------------------------------------------------------------------------
p <- ( 100 : 900 ) / 1000
plot( p, qprodcor( p, -1 ), type ='l', col = 'red', ylim = c(-2,2), ylab = 'Quantile' )
lines( p, qprodcor( p, -0.5 ), col = 'orange' )
lines( p, qprodcor( p, 0 ), col = 'black' )
lines( p, qprodcor( p, 0.5 ), col = 'green' )
lines( p, qprodcor( p, 1 ), col = 'blue' )
legend(
    'bottomright',
    legend = c( -1, -0.5, 0, 0.5, 1 ),
    col = c( 'red', 'orange', 'black', 'green', 'blue' ),
    lty = 1,
    title = expression( rho )
)

## -----------------------------------------------------------------------------
x <- ( (-500) : 500 ) / 1000
plot( x, rho_from_median( x ), type ='l', ylab = 'Rho', xlab = 'Median' )
# coarse approximation slope is given by chisq median
em <- qchisq( 0.5, 1 ) # [1] 0.4549364
abline( 0, 1/em, lty = 2, col = 'gray' )

#' Meta-Analysis of Correlated Genetic Association Studies
#'
#' This function accepts the summary statistics from several studies, estimates their z-score correlation matrix, and performs the meta-analysis taking those correlations into account.
#'
#' @param studies A list of `S` studies, each of which is a data frame with the following required columns: `id`, `chr`, `pos`, `beta`, `se`, `n`.
#' Column names have to match exactly.
#' `id` is used to match variants between studies (they must be unique for different variants, and be the same for the same variant).
#' `chr` and `pos` are used solely to sort variants after the studies have been merged.
#' `beta` and `se` are required to perform meta-analysis.
#' `n` is used to report locus-specific total sample sizes under missingness.
#' @param median If `TRUE` (default), estimates correlations from sample medians instead of means.
#' Passed to [estimate_R()].
#' @param df Degree of freedom for calculating the p-values from the z-scores (default of 1 is best practically always).
#' @param tol Determinant tolerance for singularity test of R estimate
#'
#' @return A list with two named elements:
#' - `assoc`: the meta-analyzed study, a tibble with columns `id`, `chr`, `pos`, `n`, `n_studies`, `beta`, `se`, `z`, and `p`; sorted by `chr` and `pos`.
#' - `R`: the `S`-by-`S` estimated z-score covariance matrix
#'
#' @examples
#' # construct two toy studies just to run example, with minimal columns
#' study1 <- data.frame(
#'   id = paste0( 'rs', 1:5 ),
#'   chr = 1,
#'   pos = 1:5,
#'   n = 2000,
#'   beta = rnorm( 5 ),
#'   se = rnorm( 5 )
#' )
#' # note the second study is missing the 5th SNP, this is fine
#' study2 <- data.frame(
#'   id = paste0( 'rs', 1:4 ),
#'   chr = 1,
#'   pos = 1:4,
#'   n = 5000,
#'   beta = rnorm( 4 ),
#'   se = rnorm( 4 )
#' )
#'
#' # gather the studies in a list
#' studies <- list( study1, study2 )
#' # this performs the meta-analysis modeling covariance!
#' out <- metalcor( studies )
#' # this is the meta-analyzed association table
#' out$assoc
#' # and this is the estimated study covariance matrix
#' out$R
#'
#' @seealso [estimate_R()]
#' 
#' @export
metalcor <- function( studies, median = TRUE, df = 1, tol = 1e-8 ) {
    # check inputs
    if ( missing( studies ) )
        stop( '`studies` is mandatory!' )
    if ( !is.list( studies ) )
        stop( '`studies` must be a list!' )
    S <- length( studies )
    if ( S < 2 )
        stop( 'Provide at least two studies!' )
    
    # this merges the studies!
    study_full <- merge_studies( studies )

    # pull out the desired matrices to pass to the math code
    betas <- as.matrix( dplyr::select( study_full, tidyselect::num_range( "beta", 1:S ) ) )
    ses <- as.matrix( dplyr::select( study_full, tidyselect::num_range( "se", 1:S ) ) )
    # colnames don't add anything here, better to remove them for clarity
    colnames( betas ) <- NULL
    colnames( ses ) <- NULL
    # exclude the separate betas and ses from the data frames now
    study_full <- dplyr::select( study_full, 'id', 'chr', 'pos', 'n' )

    # estimate the correlation matrix
    # compute z scores matrix on the fly, by elementwise normalization
    R <- estimate_R( betas / ses, median = median, tol = tol )
    
    # this performs the actual calculations
    gwas_meta <- meta_corr_math( betas, ses, R, df = df )

    # add back the id/chr/pos and we're done
    gwas_meta <- dplyr::bind_cols( study_full, gwas_meta )
    # return R matrix too
    list(
        assoc = gwas_meta,
        R = R
    )
}

merge_studies <- function( studies ) {
    S <- length( studies )

    # check that each element is a data frame, errors get confusing otherwisee
    for ( j in 1 : S )
        if ( !is.data.frame( studies[[ j ]] ) )
            stop( 'Study ', j, ' was not a data frame!' )
        
    # make a merged data frame, doing full join of two studies at the time
    # 1) each study we toss the non-essential columns,
    # 2) columns to merge on (id, chr, pos) are kept same name in each study pre-merge, but columns to keep different per study are explicitly numbered
    study_full <- dplyr::select( studies[[1]], 'id', 'chr', 'pos', beta1 = 'beta', se1 = 'se', n1 = 'n' )
    for ( j in 2 : S ) {
        # use only desired columns
        study_j <- dplyr::select( studies[[j]], 'id', 'chr', 'pos', 'beta', 'se', 'n' )
        # append number to columns we want differentiated
        study_j <- dplyr::rename_with( study_j, ~ paste0(.x, j), .cols = c( 'beta', 'se', 'n' ) )
        # now we can apply the join
        study_full <- dplyr::full_join( study_full, study_j, by = dplyr::join_by( 'id', 'chr', 'pos' ) )
    }

    # trivial sum of sample sizes across non-missing studies, no other use for the n's
    study_full$n <- rowSums( dplyr::select( study_full, tidyselect::num_range( "n", 1:S ) ), na.rm = TRUE )
    # immediately remove the separate n values
    study_full <- dplyr::select( study_full, !tidyselect::num_range( "n", 1:S ) )

    # data can be kinda sorted but not quite, lets sort now (only use for chr/pos) 
    study_full <- dplyr::arrange( study_full, 'chr', 'pos' )

    # done merging!
    study_full
}

# this does the actual math, separated from the more tedious alignment code
meta_corr_math <- function( betas, ses, R, df = 1 ) {
    # useful to know the total number of studies
    S <- ncol( betas )
    # count number of studies with observations per locus, nice stat and helps a bit with code
    Ss <- rowSums( !is.na( betas ) )

    # construct the sigma of every locus explicitly, appears to behave way better numerically, but should be slower
    m <- nrow( betas )
    ses_meta <- rep.int( NA, m )
    betas_meta <- rep.int( NA, m )
    for ( i in 1 : m ) {
        # deal with missingness
        # we pre-calculated numbers of observations per locus, pull that now here
        S_obs <- Ss[ i ]
        # can't think of a reasonable scenario where all data is missing, but just handle it anyway
        # the output vectors are filled with NAs, if we don't touch them we're good in this case
        if ( S_obs == 0 )
            next
        # pull vectors now, we'll need them
        ses_i <- ses[ i, ]
        betas_i <- betas[ i, ]
        R_i <- R # a copy, in case it needs subsetting
        if ( S_obs < S ) {
            # subset everything now, since it's needed
            # se, beta will be missing together under any reasonable scenario
            indexes <- !is.na( ses_i )
            ses_i <- ses_i[ indexes ]
            betas_i <- betas_i[ indexes ]
            # shortcut analysis if there's just one non-missing study
            if ( S_obs == 1 ) {
                # just copy the one non-missing value
                ses_meta[ i ] <- ses_i
                betas_meta[ i ] <- betas_i
                # move on to the next SNP! 
                next
            }
            # only in this case it's worth subsetting
            R_i <- R_i[ indexes, indexes ]
        }
        # form explicit beta covariance matrix, using correlation calculated earlier
        D <- diag( ses_i )
        # try to invert, though in some cases this fails.  This is always because some ses_i values are very close to zero (R_i is otherwise well behaved in practice, and was checked earlier anyway)
        Sigma_inv <- try( solve( D %*% R_i %*% D ), silent = TRUE )
        if ( "try-error" %in% class( Sigma_inv ) ) {
            # again, one sigma is extremely close to zero...
            # first let's identify it
            j <- which.min( ses_i )
            # in these cases precision is kinda pointless, asymptotics show the beta and se of that worse case is roughly the value approached (with some annoying constants we just ignore here)
            # if beta=0 but se>0, below we'll calculate a p-value of 1 (this is perfect)
            # if se=0 and beta>0 (I think this unlikely), we'd get z=Inf and p=0, let's avoid that!!!  Also cap extreme z-scores (bigger than 4 in this case), force beta to zero in those cases so z score is also zero.
            # lastly, se=0 and beta=0 gives z=NaN and p=NaN too, let's keep that too and hope it's not too unpleasant downstream (at least for my evals (aucpr, srmsdp, infl) this is fine)
            ses_meta[ i ] <- ses_i[ j ]
            betas_meta[ i ] <- if ( ses_i[ j ] == 0 || betas_i[ j ] / ses_i[ j ] > 4 ) 0 else betas_i[ j ]
        } else {
            # regular handling, most common
            denom_i <- sum( Sigma_inv )
            ses_meta[ i ] <- 1 / sqrt( denom_i )
            betas_meta[ i ] <- sum( Sigma_inv %*% betas_i ) / denom_i
        }
    }
    
    # meta z-scores!
    zs_meta <- betas_meta / ses_meta
    # p-values
    ps_meta <- stats::pchisq( zs_meta^2, df, lower.tail = FALSE )
    # organize into a tibble and return
    gwas_meta <- tibble::tibble(
                             n_studies = Ss,
                             beta = betas_meta,
                             se = ses_meta,
                             z = zs_meta,
                             p = ps_meta
                         )
}

validate_prodcor <- function( n, x, p, rho ) {
    ### dprodcor

    # create failure on purpose
    expect_error( dprodcor() )
    expect_error( dprodcor( x ) )
    expect_error( dprodcor( rho = rho ) )
    expect_error( dprodcor( x, x ) )

    # a successful case
    expect_silent( 
        y <- dprodcor( x, rho )
    )
    expect_true( is.numeric( y ) )
    expect_true( !anyNA( y ) )
    expect_equal( length( y ), n )
    expect_true( min( y ) >= 0 )

    ### pprodcor

    # create failure on purpose
    expect_error( pprodcor() )
    expect_error( pprodcor( x ) )
    expect_error( pprodcor( rho = rho ) )
    expect_error( pprodcor( x, x ) )
    
    # a successful case
    expect_silent( 
        y <- pprodcor( x, rho )
    )
    expect_true( is.numeric( y ) )
    expect_true( !anyNA( y ) )
    expect_equal( length( y ), n )
    expect_true( min( y ) >= 0 )
    # here additionally we expect values to increase monotonically, but we need to order by x
    expect_true( all( diff( y[ order( x ) ] ) >= 0 ) )

    ### qprodcor

    # create failure on purpose
    expect_error( qprodcor() )
    expect_error( qprodcor( p ) )
    expect_error( qprodcor( rho = rho ) )
    expect_error( qprodcor( p, p ) )
    
    # a successful case
    expect_silent( 
        y <- qprodcor( p, rho )
    )
    expect_true( is.numeric( y ) )
    expect_true( !anyNA( y ) )
    expect_equal( length( y ), n )
    # quantiles have unlimited range

    # also test p of 0 or 1 specifically
    expect_silent( 
        y <- qprodcor( p = c(0,1), rho )
    )
    # limits are all reals, except in two edge cases
    y_exp <- c( if ( rho == 1 ) 0 else -Inf, if ( rho == -1 ) 0 else Inf)
    expect_equal( y, y_exp )

    ### rprodcor

    # create failure on purpose
    expect_error( rprodcor() )
    expect_error( rprodcor( n ) )
    expect_error( rprodcor( rho = rho ) )
    expect_error( rprodcor( n, n ) )
    
    # a successful case
    expect_silent( 
        y <- rprodcor( n, rho )
    )
    expect_true( is.numeric( y ) )
    expect_true( !anyNA( y ) )
    expect_equal( length( y ), n )
    # quantiles have unlimited range
}

test_that("*prodcor family works", {
    # simulate some data
    n <- 100
    x <- rnorm( n )
    p <- runif( n )

    # validate all cases for a random rho
    validate_prodcor( n, x, p, rho = runif( 1, -1, 1 ) )
    # some special/edge cases
    validate_prodcor( n, x, p, rho = 1 )
    validate_prodcor( n, x, p, rho = -1 )
    # not really a "edge" case, but still expected to be a very common request
    validate_prodcor( n, x, p, rho = 0 )

    # a specific relevant edge case, for median calculations
    # backtracking from quantiles to cumulatives
    # these should decrease as rho increases
    y99 <- pprodcor( em, 0.99 )
    y999 <- pprodcor( em, 0.999 )
    y1 <- pprodcor( em, 1 )
    expect_true( y99 > y999 )
    expect_true( y999 > y1 )

    # downstream effect 
    y99 <- qprodcor( 0.5, 0.99 )
    y999 <- qprodcor( 0.5, 0.999 )
    y1 <- qprodcor( 0.5, 1 )
    expect_true( y99 < y999 )
    expect_true( y999 < y1 )
})

test_that( "rho_from_median works", {
    # size of window around troublesome edge cases
    eps <- 1e-4
    # create these many samples from each case (4 cases), plus 3 fixed cases
    nc <- 10

    # these are all the cases to test!
    x <- c(
        # fixed cases
        -1, 0, 1,
        # test random values near 1
        em * runif( nc, 1 - eps, 1 + eps ),
        # test random values near -1
        - em * runif( nc, 1 - eps, 1 + eps ),
        # test random values near 0
        runif( nc, -eps, eps ),
        # test totally random numbers
        runif( nc, -1, 1 )
    )
    # actual length
    n <- length( x )

    # cause errors on purpose
    expect_error( rho_from_median( ) )
    expect_error( rho_from_median( letters ) )

    # a succesful case
    expect_silent( 
        y <- rho_from_median( x )
    )
    expect_true( is.numeric( y ) )
    expect_true( !anyNA( y ) )
    expect_equal( length( y ), n )
    # these should have the same sign
    expect_true( min( y * x ) >= 0 )

    # run a new example from vignette that failed (until debugged)
    x <- ( (-1500) : 1500 ) / 1000
    n <- length( x )
    expect_silent( 
        y <- rho_from_median( x )
    )
    expect_true( is.numeric( y ) )
    expect_true( !anyNA( y ) )
    expect_equal( length( y ), n )
    # these should have the same sign
    expect_true( min( y * x ) >= 0 )
})

test_that( "estimate_R works", {
    # dimensions of simulation
    m <- 10000
    # true correlation matrix
    R <- matrix(
        c(
            1.0, 0.2, 0.0,
            0.2, 1.0, 0.1,
            0.0, 0.1, 1.0
        ),
        nrow = 3, ncol = 3
    )
    # use Cholesky decomposition to simulate via affine transform
    L <- chol( R )
    Z <- matrix( rnorm( m * 3 ), nrow = m, ncol = 3 ) %*% L

    # calulate estimates
    for ( median in c(TRUE, FALSE) ) {
        expect_silent(
            R_est <- estimate_R( Z, median = median )
        )
        expect_true( is.matrix( R_est ) )
        expect_true( is.numeric( R_est ) )
        expect_equal( dim( R_est ), c(3, 3) )
        expect_true( min( diag( R_est ) ) >= 0 )
    }
})



test_that( "metalcor works", {
    # pick a dense subset of 1000 loci, with some non-overlap to test missingness properly
    n <- 1000
    n_sub <- 950
    # number of studies
    S <- 3

    # construct studies
    studies <- NULL
    for ( i in 1 : S ) {
        # ids have to be unique
        # have more than one chr, but to keep high overlap let's hav eit be deterministic with pos
        ids <- sample.int( n, n_sub )
        study <- data.frame(
            id = ids,
            chr = 1 + round( ids / 250 ),
            pos = ids,
            n = i * 1000,
            beta = rnorm( n_sub ),
            se = rnorm( n_sub )
        )
        studies <- c( studies, list( study ) )
    }

    for ( median in c(TRUE, FALSE) ) {
        expect_silent(
            out <- metalcor( studies, median = median )
        )
    }
})

#' @rdname prodcor
#' @order 4
#' @export
rprodcor <- function( n, rho ) {
    # check inputs
    if ( missing( n ) )
        stop( '`n` is mandatory!' )
    if ( missing( rho ) )
        stop( '`rho` is mandatory!' )
    if ( !is.numeric( n ) )
        stop( '`n` must be numeric!' )
    if ( !is.numeric( rho ) )
        stop( '`rho` must be numeric!' )
    # if n is a vector, replace it with its length, as rnorm does
    if ( length( n ) > 1 ) {
        n <- length( n )
    } else {
        # otherwise make sure it's a positive integer
        n <- as.integer( n )
        if ( n < 1 )
            stop( '`n` must round to a positive value!' )
    }
    # x can be a vector, but rho cannot
    if ( length( rho ) != 1 )
        stop( '`rho` must be scalar!' )
    # in this function, rho has to be in [-1,1]
    if ( rho > 1 )
        stop( '`rho` must be equal to or less than 1!' )
    if ( rho < -1 )
        stop( '`rho` must be equal to or greater than -1!' )

    # use chi squared if rho=1
    if ( rho == 1 ) {
        return( stats::rchisq( n, df = 1 ) )
    } else if ( rho == -1 )
        # this is the adequate transformation for negative correlations
        return( - stats::rchisq( n, df = 1 ) )
    # else continue...
    
    # the goal is to generate two random standard normal variables that are correlated, then multiply them
    # use affine transformation of the covariance matrix R
    # R <- matrix( c( 1, rho, rho, 1 ), 2, 2)
    # cholesky has closed form! (this is transposed from what `chol` returns, but it is what we want for this transform)
    U <- matrix( c( 1, rho, 0, sqrt(1 - rho^2) ), 2, 2 )
    
    # draw the pair of independent standard normals, arranged as a wide matrix with two rows
    # multiplying by U matrix gives us the desired correlated variables
    X <- U %*% matrix( stats::rnorm( 2 * n ), nrow = 2, ncol = n )
    # lastly, multiply the two values of each column and return, as a regular vector
    drop( X[1,] * X[2,] )
}

#' The Correlated Standard Normal Product Distribution
#'
#' Density, cumulative, quantile, and random generation for the product of two correlated standard normal variables with correlation parameter `rho`.
#'
#' `pprodcor` does not have a closed form, so it is calculated by numerical integration of `dprodcor`.
#' Furthermore, `dprodcor(0)` is infinite, so in order for numerical integration to succeed, we exclude the window `c(-eps, eps)` for arguments near zero.  `eps` is the initial value, but if failure is still encountered, `eps` is incremented by factors of 10 until successful.  (For positive arguments integration from above is used instead, subtracted from 1.)
#' `qprodcor` also does not have a closed form, so it is calculated using a root finder on `pprodcor`, which makes it very slow.
#'
#' @param x Vector of quantiles.
#' @param p Vector of probabilities.
#' @param n Number of observations.  If `length(n) > 1`, the length is taken to be the number required.
#' @param rho Correlation parameter, must be a scalar in \[-1, 1\].
#' @param eps Near zero value to use for integrating around the divergence at `x=0`.
#'
#' @return `dprodcor` gives the density, `pprodcor` the cumulative, and `qprodcor` the quantile function.  `rprodcor` generates random deviates.  The length of the result is determined by `n` for `rnorm`, and it is the length of `x` or `p` for the other functions.
#'
#' @references Nadarajah, Saralees, and Tibor K. Pogány. “On the Distribution of the Product of Correlated Normal Random Variables.” Comptes Rendus Mathematique 354, no. 2 (2016): 201–4. \doi{10.1016/j.crma.2015.10.019}.
#'
#' Gaunt, Robert E. “The Basic Distributional Theory for the Product of Zero Mean Correlated Normal Random Variables.” Statistica Neerlandica 76, no. 4 (2022): 450–70. \doi{10.1111/stan.12267}.
#'
#' @examples
#' n <- 10
#' x <- rnorm( n )
#' p <- runif( n )
#' rho <- 0.8
#' dprodcor( x, rho )
#' pprodcor( x, rho )
#' qprodcor( p, rho )
#' rprodcor( n, rho )
#'
#' @name prodcor
#' @order 1
#' @export
dprodcor <- function( x, rho ) {
    # check inputs
    if ( missing( x ) )
        stop( '`x` is mandatory!' )
    if ( missing( rho ) )
        stop( '`rho` is mandatory!' )
    if ( !is.numeric( x ) )
        stop( '`x` must be numeric!' )
    if ( !is.numeric( rho ) )
        stop( '`rho` must be numeric!' )
    # x can be a vector, but rho cannot
    if ( length( rho ) != 1 )
        stop( '`rho` must be scalar!' )
    # in this function, rho has to be in [-1,1]
    if ( rho > 1 )
        stop( '`rho` must be equal to or less than 1!' )
    if ( rho < -1 )
        stop( '`rho` must be equal to or greater than -1!' )
    # x can be any real number

    # to handle negative rho best in final approx, take advantage of symmetry, assume positive rho onward:
    if ( rho < 0 ) {
        rho <- - rho
        x <- -x
    }
    
    # handle some trivial cases (rho == -1 handled by above symmetry transform)
    if ( rho == 1 )
        return( stats::dchisq( x, df = 1 ) )
    # else continue
    
    # this is the determinant of R
    d <- 1 - rho^2
    # function is in terms of this converted variable
    x <- x / d
    # density from Nadarajah 16
    y <- 1 / ( pi * sqrt( d ) ) * exp( rho * x ) * besselK( abs(x), nu = 0 )
    # just recalculate anything that evaluated to NA with the alternate formula (not sure how worth it it is to find thresholds to decide
    indexes <- is.na( y )
    if ( any( indexes ) ) {
        # handle both positive and negative cases...
        indexes_neg <- x[ indexes ] < 0
        y[ indexes[ indexes_neg ] ] <- 0
        # subset positive cases
        indexes <- indexes[ !indexes_neg ]
        x <- x[ indexes ]
        y[ indexes ] <- 1 / sqrt( 2 * pi * x ) * exp( - x / ( 1 + rho ) )
    }
    # done!
    y
}

#' @rdname prodcor
#' @order 3
#' @export
qprodcor <- function( p, rho ) {
    # check inputs
    if ( missing( p ) )
        stop( '`p` is mandatory!' )
    if ( missing( rho ) )
        stop( '`rho` is mandatory!' )
    if ( !is.numeric( p ) )
        stop( '`p` must be numeric!' )
    if ( !is.numeric( rho ) )
        stop( '`rho` must be numeric!' )
    # p can be a vector, but rho cannot
    if ( length( rho ) != 1 )
        stop( '`rho` must be scalar!' )
    # in this function, rho has to be in [-1,1]
    if ( rho > 1 )
        stop( '`rho` must be equal to or less than 1!' )
    if ( rho < -1 )
        stop( '`rho` must be equal to or greater than -1!' )
    # and p has to be a probability
    if ( min( p ) < 0 )
        stop( '`p` must be non-negative!' )
    if ( max( p ) > 1 )
        stop( '`p` must be smaller or equal to 1!' )

    # use chi squared if rho=1
    if ( rho == 1 ) {
        return( stats::qchisq( p, df = 1 ) )
    } else if ( rho == -1 )
        # this is the adequate transformation for negative correlations
        return( - stats::qchisq( 1 - p, df = 1 ) )
    # else continue...
    
    # start calculating individual values
    n <- length( p )
    y <- rep.int( NA, n )
    # this is a coarse approximation useful as a starting point for the root finder, which is particularly tuned for median finding
    # guess quantile under chi-squared (which corresponds to rho=1)
    # reverse quantiles for negative correlations
    # dampen by given rho, also works well when negative
    y2 <- rho * stats::qchisq( if ( rho > 0 ) p else 1 - p, df = 1 )
    
    for ( i in 1 : n ) {
        pi <- p[ i ]

        # handle edge cases
        if ( pi == 1 ) {
            y[ i ] <- Inf
        } else if ( pi == 0 ) {
            y[ i ] <- -Inf
        } else {
            # these bounds work well for median, but in other cases may be off, so allow for interval to be extended (unfortunately you can't just set infinities)
            # add tolerance here too to ensure "opposite signs" at lower and upper
            if ( rho > 0 ) {
                lower <- y2[i] - 0.069
                upper <- y2[i] + 1e-3
            } else {
                lower <- y2[i] - 1e-3
                upper <- y2[i] + 0.069
            }
            y[ i ] <- stats::uniroot( function( z ) pprodcor( z, rho ) - pi, c( lower, upper ), extendInt = 'yes' )$root
        }
    }
    y
}

#' Meta-Analysis of Correlated Genetic Association Studies
#'
#' `metalcor` generalizes the genetic association study meta-analysis software METAL to model studies with correlated statistics, which arise due to cryptic relatedness between studies.
#' 
#' This package also models the distribution of the product of correlated standard normal variables.
#' This is crucial for estimating correlation using the median product of z-scores, since in this case the median differs substantially from the mean.
#' The median provides robustness from the outliers caused by strongly associated loci.
#'
#' @examples
#' # construct two toy studies just to run example, with minimal columns
#' study1 <- data.frame(
#'   id = paste0( 'rs', 1:5 ),
#'   chr = 1,
#'   pos = 1:5,
#'   n = 2000,
#'   beta = rnorm( 5 ),
#'   se = rnorm( 5 )
#' )
#' # note the second study is missing the 5th SNP, this is fine
#' study2 <- data.frame(
#'   id = paste0( 'rs', 1:4 ),
#'   chr = 1,
#'   pos = 1:4,
#'   n = 5000,
#'   beta = rnorm( 4 ),
#'   se = rnorm( 4 )
#' )
#' 
#' library(metalcor)
#' # gather the studies in a list
#' studies <- list( study1, study2 )
#' # this performs the meta-analysis modeling covariance!
#' out <- metalcor( studies )
#' # this is the meta-analyzed association table
#' out$assoc
#' # and this is the estimated study covariance matrix
#' out$R
#'
#' # if you want to focus on the Z score covariance, you can do this separately
#' # (metalcor does it internally too):
#' Z <- cbind( study1$beta / study1$se, study2$beta / study2$se )
#' R <- estimate_R( Z )
#'
#' # lastly, let's look at the distribution of the product of correlated z scores
#' x <- Z[ , 1] * Z[ , 2]
#' # this estimates the correlation from the median product
#' rho_est <- rho_from_median( median( x ) )
#'
#' # the underlying distribution of these products of correlated standard normal variables
#' # is described by the `*prodcor` family:
#' # simulate some data again
#' rho <- 0.6
#' n <- 100
#' x <- rnorm( n )
#' p <- runif( n )
#' # density function
#' dprodcor( x, rho )
#' # cumulative function
#' pprodcor( x, rho )
#' # quantile function
#' qprodcor( p, rho )
#' # random deviates
#' rprodcor( n, rho )
#' 
#' @keywords internal
"_PACKAGE"

## usethis namespace: start
## usethis namespace: end
NULL

#' @rdname prodcor
#' @order 2
#' @export
pprodcor <- function( x, rho, eps = 1e-8 ) {
    # check inputs
    if ( missing( x ) )
        stop( '`x` is mandatory!' )
    if ( missing( rho ) )
        stop( '`rho` is mandatory!' )
    if ( !is.numeric( x ) )
        stop( '`x` must be numeric!' )
    if ( !is.numeric( rho ) )
        stop( '`rho` must be numeric!' )
    # x can be a vector, but rho cannot
    if ( length( rho ) != 1 )
        stop( '`rho` must be scalar!' )
    # in this function, rho has to be in [-1,1]
    if ( rho > 1 )
        stop( '`rho` must be equal to or less than 1!' )
    if ( rho < -1 )
        stop( '`rho` must be equal to or greater than -1!' )
    # x can be any real number
    if ( eps <= 0 )
        stop( '`eps` must be strictly positive!' )
    
    # use chi squared if rho=1
    if ( rho == 1 ) {
        return( stats::pchisq( x, df = 1 ) )
    } else if ( rho == -1 )
        # this is the adequate transformation for negative correlations
        return( 1 - stats::pchisq( -x, df = 1 ) )
    # else continue...

    # interpolate for rho between 0.95 and 1, where inaccuracy blows up
    # I made a lot of plots and determined that this threshold works best
    rho_cut <- 0.95
    if ( rho > rho_cut ) {
        # calculate values at the two stable points
        y1 <- stats::pchisq( x, df = 1 )
        y2 <- pprodcor( x, rho_cut, eps = eps )
        # and interpolate!
        w <- ( 1 - rho ) / ( 1 - rho_cut )
        y_out <- y1 * ( 1 - w ) + y2 * w
        return( y_out )
    } else if ( rho < -rho_cut ) {
        # repeat on negative end
        y1 <- 1 - stats::pchisq( -x, df = 1 )
        y2 <- pprodcor( x, -rho_cut, eps = eps )
        w <- ( 1 + rho ) / ( 1 - rho_cut )
        y_out <- y1 * ( 1 - w ) + y2 * w
        return( y_out )
    }

    # start calculating individual values
    n <- length( x )
    y <- rep.int( NA, n )
    for ( i in 1 : n ) {
        xi <- x[ i ]
        if ( xi < -eps ) {
            try( y[ i ] <- stats::integrate( dprodcor, lower = -Inf, upper = xi, rho = rho )$value, silent = TRUE )
            while ( is.na( y[ i ] ) ) {
                # failures are expected near zero, also make bigger until it succeeds
                xi <- xi * 10
                try( y[ i ] <- stats::integrate( dprodcor, lower = -Inf, upper = xi, rho = rho )$value, silent = TRUE )
            }
        } else if ( xi < eps ) {
            # this case ( xi ~ 0 ) fails often when rho is large :(
            eps2 <- eps
            try( y[ i ] <- stats::integrate( dprodcor, lower = -Inf, upper = -eps2, rho = rho )$value, silent = TRUE )
            while ( is.na( y[ i ] ) ) {
                # make eps bigger until we get a good number
                eps2 <- eps2 * 10
                try( y[ i ] <- stats::integrate( dprodcor, lower = -Inf, upper = -eps2, rho = rho )$value, silent = TRUE )
            }
        } else {
            try( y[ i ] <- 1 - stats::integrate( dprodcor, lower = xi, upper = Inf, rho = rho )$value, silent = TRUE )
            while ( is.na( y[ i ] ) ) {
                # failures are expected near zero, also make bigger until it succeeds
                xi <- xi * 10
                try( y[ i ] <- 1 - stats::integrate( dprodcor, lower = xi, upper = Inf, rho = rho )$value, silent = TRUE )
            }
        }
    }
    y
}

# constant, marks transition from covariance to variance
em <- qchisq( 0.5, 1 ) # [1] 0.4549364

#' Estimated Correlations from Sample Medians of the Correlated Standard Normal Product Distribution
#'
#' This code implements estimation from the sample median of the correlation of a product of two correlated standard normal variables.
#' While this estimation is straightforward from the mean, using the median requires the transformation implemented here because the distribution has heavy tails, so for positive correlations the median is much smaller than the mean.
#' The median version is desired due to its robustness to outliers.
#'
#' The highest correlation of `rho = 1` results in a median of only `q~0.455`.  To permit application to arbitrary data, including data that does not satisfy assumptions and is therefore inflated, the function returns `x/q` for elements whose absolute values of `x/q` exceed 1, and can therefore return values that exceed \[-1, 1\].
#'
#' @param x vector of sample medians
#'
#' @return Vector of estimated correlations, extended for inflated cases.
#'
#' @examples
#'
#' # a large number of samples is required for the median to yield an accurate estimate
#' n <- 10000
#' rho <- 0.3
#' x <- median( rprodcor( n, rho ) )
#' rho_from_median( x )
#'
#' @seealso [qprodcor()]
#' 
#' @export
rho_from_median <- function( x ) {
    # check inputs
    if ( missing( x ) )
        stop( '`x` is mandatory!' )
    if ( !is.numeric( x ) )
        stop( '`x` must be numeric!' )
    # x can otherwise be a vector with any real values...
    
    n <- length( x )
    y <- rep.int( NA, n )
    for ( i in 1 : n ) {
        # solutions are close to this in a sense, and plot shows it as a useful bound (sign dependent)
        rho0 <- x[ i ] / em
        if ( abs( rho0 ) >= 1 - 1e-3 ) {
            # desired value for variance case, which is only case expected to give huge values
            y[ i ] <- rho0
        } else {
            # add tolerance here too to ensure "opposite signs" at lower and upper
            if ( rho0 > 0 ) {
                lower <- rho0 - 1e-3
                upper <- min( 1, rho0 + 0.15 )
            } else {
                lower <- max( -1, rho0 - 0.15 )
                upper <- rho0 + 1e-3
            }
            y[ i ] <- stats::uniroot( function( rho ) qprodcor( 0.5, rho ) - x[ i ], c(lower, upper) )$root
        }
    }
    y
}

#' Estimate Covariance Matrix of Study Z-scores
#'
#' The default "median" estimator is expected to be more robust to outliers (present due to causal variants and linkage disequilibrium).
#' For completeness, the more standard "mean" estimator is also implemented, which is better when there are no outliers.
#' The determinant is also tested, and if its absolute value is less than `tol` an error is triggered, warning the user that perhaps the same study was included multiple times (as this is otherwise expected to be extremely rare).
#'
#' @param Z Matrix of z-scores, loci along rows, `S` studies along columns.  Missing values can be present and are appropriately ignored.
#' @param median If `TRUE`, uses [rho_from_median()] to calculate covariance values from sample medians; otherwise, sample means are used.
#' @param tol Determinant tolerance for singularity test
#'
#' @return The `S`-by-`S` covariance matrix.
#'
#' @examples
#'
#' # simulate some correlated Z-scores for 3 studies and `m` loci
#' m <- 10000
#' # true correlation matrix
#' R <- matrix(
#'   c( 1.0, 0.2, 0.0,
#'      0.2, 1.0, 0.1,
#'      0.0, 0.1, 1.0 ),
#'   nrow = 3, ncol = 3
#' )
#' # use Cholesky decomposition to simulate via affine transform
#' L <- chol( R )
#' Z <- matrix( rnorm( m * 3 ), nrow = m, ncol = 3 ) %*% L
#'
#' # calulate estimates
#' estimate_R( Z )
#' estimate_R( Z, median = FALSE )
#' # compare to naive covariance estimate, which does not assume zero mean for z-scores
#' cov( Z, use = 'pairwise.complete.obs' )
#'
#' @seealso [rho_from_median()]
#' 
#' @export
estimate_R <- function ( Z, median = TRUE, tol = 1e-8 ) {
    # check inputs
    if ( missing( Z ) )
        stop( '`Z` is mandatory!' )
    if ( !is.matrix( Z ) )
        stop( '`Z` must be a matrix!' )
    if ( !is.numeric( Z ) )
        stop( '`Z` must be numeric!' )
    
    # estimate z-score correlation matrix
    if ( median ) {
        # unfortunately we have to build it more carefully...
        S <- ncol( Z ) # number of studies
        R <- matrix( NA, S, S )
        for ( j in 1 : S ) {
            zj <- Z[ , j ]
            for ( k in 1 : j ) {
                mjk <- median( zj * Z[ , k ], na.rm = TRUE )
                rjk <- rho_from_median( mjk )
                R[ j, k ] <- rjk
                R[ k, j ] <- rjk
            }
        }
    } else {
        # this forms the correlation estimate, handles missingness but overfits means
        #R <- cov( Z, use = 'pairwise.complete.obs' )
        
        # this version assumes null more properly, but does not handle missingness
        #R <- crossprod( Z ) / nrow( Z )
        
        # when there's missingness, this is more painful
        # first, number of complete observations
        M <- crossprod( !is.na( Z ) )
        # now missing cases can be zeroed
        Z[ is.na( Z ) ] <- 0
        # we can now compute the final estimate
        R <- crossprod( Z ) / M
    }

    # R is going to have to be invertible... check determinant now
    # (sample estimates on reasonable data are extremely unlikely to cause problems, data essentially has to be duplicated for problems to occur)
    if ( abs( det( R ) ) < tol )
        stop( 'Z-score correlation matrix is numerically singular!  Did you input the same study more than one time?  Det = ', det( R ) )
    
    R
}

---
title: "metalcor"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{metalcor}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
                      collapse = TRUE,
                      comment = "#>",
                      fig.width = 6, fig.height = 4, out.width = "100%"
                  )
```

This packages makes it easy to meta-analyze multiple genetic association studies that may be correlated, which we established occurs when there is cryptic relatedness between the studies, though it could also happen due to other forms of confounding.
The standard method for genetic association meta analysis, METAL, assumes that the studies are independent, so when they are not this results in inflated statistics in the meta-analyzed output, even when input studies are well calibrated.

At the end we present important distributional modeling of products of correlated standard normal variables, which enables estimation of correlations from median estimates in this setting where large outliers are expected.


## Simulate correlated studies for test

(For real data you don't have to do this, instead `study1`, `study2`, etc would be data you already have).

Let's start by simulating a big enough example with three studies and 10K loci.
This simulation will have correlated statistics, but it won't have any real associations or LD, so in that sense it is simplistic and does not feature some other challenging features of real data, but it does have correlated statistics and we can demonstrate that they are handled well and that the correlation structure is well estimated.
```{r}
# number of studies
S <- 3
# number of loci
m <- 10000
# this is the true covariance matrix of this simulation
R <- matrix(
    c( 1.0, 0.2, 0.0,
      0.2, 1.0, 0.1,
      0.0, 0.1, 1.0 ),
    nrow = 3, ncol = 3
)

# simulate the correlated Z scores first
# use Cholesky decomposition to simulate via affine transform
L <- chol( R )
Z <- matrix( rnorm( m * 3 ), nrow = m, ncol = 3 ) %*% L

# construct some trivial study summary statistics with the above Z scores
library(tibble)
library(dplyr)
study1 <- tibble(
    id = 1 : m,
    chr = ceiling( id / m * 10 ),
    pos = id,
    n = 1000,
    z = Z[, 1],
    se = runif( m, 0, 1 / sqrt( n ) ),
    beta = z * se
)
# this copies id/chr/pos between studies, adds study-specific info.
# note that, besides the different Z scores, there's also different sample sizes per study,
# and standard errors scale inversely proportional to the square root of study size
study2 <- study1 %>%
    select( id, chr, pos) %>%
    mutate(
        n = 2000,
        z = Z[, 2],
        se = runif( m, 0, 1 / sqrt( n ) ),
        beta = z * se
    )
study3 <- study1 %>%
    select( id, chr, pos) %>%
    mutate(
        n = 10000,
        z = Z[, 3],
        se = runif( m, 0, 1 / sqrt( n ) ),
        beta = z * se
    )
# for realism, randomly subset studies so only 90% of loci survive, different sets per study
study1 <- study1[ sort( sample.int( m, m * 0.9) ), ]
study2 <- study2[ sort( sample.int( m, m * 0.9) ), ]
study3 <- study3[ sort( sample.int( m, m * 0.9) ), ]
```
Above, the tables contain z-scores, because we constructed them first and `beta` and `se` are derived, but `beta` and `se` are mandatory columns, as are the rest of the columns in the above example except for `z`, which are always recalculated as `beta/se` by `metalcor`.

## Perform meta-analysis

Now we perform the meta-analysis!  Once your studies are loaded onto data frames or tibbles, the process is quite simple.
```{r}
library(metalcor)

# gather studies into a list
studies <- list( study1, study2, study3 )
# pass to metalcor!
out <- metalcor( studies )
# you can quickly inspect the return value, it is a list with two named elements:
# - assoc: the meta-analyzed association table
# - R: the estimated covariance matrix between studies
out
```
There are several things to note.
First, the meta-analyzed table has every locus observed in at least one study (the number of studies for each locus is in the column `n_studies`; there's only a few loci that were removed in all three studies).
These loci are automatically sorted by `chr` and `pos` (that is their only use here; loci were matched by `id`).
For loci observed in a single study, meta-analysis is just a copy of the input data.
Lastly, note that the estimated R matrix is close to the true matrix of the simulation (in the previous section).
If the input studies had been inflated, their diagonal values would exceed 1, and in fact they ought to equal their inflation factors (in these cases, the R matrix is no longer a correlation matrix technically, but a covariance matrix).

For most users, that's it!
The meta-analyzed association table is the primary output.
However, since correlation between studies has not been studied before our work, it is important to report the estimated R matrix to determine which studies are not independent, and perhaps try to determine what causes dependence between studies more broadly.

Let's also demonstrate quickly that, despite the relative high correlations between these studies, the resulting meta-analysis is not inflated.
The following value is close to 1 ideally, and exceeds 1 under inflation/confounding:
```{r}
mean( out$assoc$z^2 )
```

## Only estimating study covariance

If for whatever reason you want to skip the meta-analysis and only study the correlation structure, you can do that!
With the starting Z-score matrix we simulated earlier, you can skip to the covariance estimate directly using the function below.
Both `estimate_R` and `admixcor` above have a parameter `median`, which if `FALSE` uses a mean-based estimator.
Compare those two estimates here, as well as the most naive estimate:
```{r}
# default median estimate
estimate_R( Z )
# mean estimate
estimate_R( Z, median = FALSE )
# standard sample covariance estimate is similar but not identical
cov( Z, use = 'pairwise.complete.obs' )
```
(This `Z` matrix doesn't have missingness, so estimates are slightly different than the earlier ones after we added missingness, but this function also handles missingness.)
The median estimator is preferred for real data, because it is robust to outliers, which in this case corresponds to strong associations.
We want to ignore strong associations because of course they are correlated between studies, but they are not correlated due to confounding.
The mean estimator is more robust if there are no outliers (since this simulation has no outliers, the mean estimator will appear better here, but real data is different!).
The last one above, the standard sample covariance estimator, is most similar to the mean estimator except it also centers the z-scores before the comparison, which is theoretically not needed for z-scores since they are supposed to have zero means, which is why we don't use that either.

## Under the hood: the correlated Standard Normal product distribution

The mean product of z-scores estimates the desired correlations `rho` between studies.
Although the median is more robust, it turns out that the naive median of the products of z-scores does not equal the mean, because this distribution has long tails.
As we show shortly, the mapping between medians and means depends on the unknown parameter `rho`, so unfortunately many calculations are needed to achieve this.
Here we summarize the features of this family of distributions and validate the calculations with simulated data.
Please see our paper for the equations.

First, use `rprodcor` to draw random values from this distribution, which is easy to do because drawing correlated standard normal values is easy.
The we compare their distribution (black) to the density (`dprodcor`) and cumulative (`pprodcor`) formulas (red), and find excellent agreement:
```{r}
n <- 10000
rho <- 0.33

# draw random values from this distribution
x <- rprodcor( n, rho )
x <- sort( x )
# this is the theoretical density function at those points
y <- dprodcor( x, rho )

# compare empirical and theoretical densities
hist( x, breaks = 100, freq = FALSE )
lines( x, y, col = 'red' )

# compare empirical and theoretical CDF now
yc <- pprodcor( x, rho )
plot( ecdf( x ) )
lines( x, yc, lty = 2, col = 'red' )
```

Let's now plot the densities for a few values of `rho`, from -1 to 1 is valid.
Note that `rho=1` is the chi-squared distribution.
Also note all of these densities diverge at `x = 0`, and that negative correlations flip the density about the y-axis, or in other words `dprodcor( x, -rho ) = dprodcor( -x, rho )`.
```{r}
x <- ( (-200) : 200 ) / 100
plot( x, dprodcor( x, -1 ), type ='l', col = 'red', ylab = 'Density' )
lines( x, dprodcor( x, -0.5 ), col = 'orange' )
lines( x, dprodcor( x, 0 ), col = 'black' )
lines( x, dprodcor( x, 0.5 ), col = 'green' )
lines( x, dprodcor( x, 1 ), col = 'blue' )
legend(
    'topright',
    legend = c( -1, -0.5, 0, 0.5, 1 ),
    col = c( 'red', 'orange', 'black', 'green', 'blue' ),
    lty = 1,
    title = expression( rho )
)
```

Repeat for the cumulative functions:
```{r}
plot( x, pprodcor( x, -1 ), type ='l', col = 'red', ylim = c(0,1), ylab = 'CDF' )
lines( x, pprodcor( x, -0.5 ), col = 'orange' )
lines( x, pprodcor( x, 0 ), col = 'black' )
lines( x, pprodcor( x, 0.5 ), col = 'green' )
lines( x, pprodcor( x, 1 ), col = 'blue' )
legend(
    'bottomright',
    legend = c( -1, -0.5, 0, 0.5, 1 ),
    col = c( 'red', 'orange', 'black', 'green', 'blue' ),
    lty = 1,
    title = expression( rho )
)
```

And the quantile functions:
```{r}
p <- ( 100 : 900 ) / 1000
plot( p, qprodcor( p, -1 ), type ='l', col = 'red', ylim = c(-2,2), ylab = 'Quantile' )
lines( p, qprodcor( p, -0.5 ), col = 'orange' )
lines( p, qprodcor( p, 0 ), col = 'black' )
lines( p, qprodcor( p, 0.5 ), col = 'green' )
lines( p, qprodcor( p, 1 ), col = 'blue' )
legend(
    'bottomright',
    legend = c( -1, -0.5, 0, 0.5, 1 ),
    col = c( 'red', 'orange', 'black', 'green', 'blue' ),
    lty = 1,
    title = expression( rho )
)
```

Using these functions, we can map sample z-score product medians to the desired correlations using `rho_from_median`, which was used internally by `estimate_R` above:
```{r}
x <- ( (-500) : 500 ) / 1000
plot( x, rho_from_median( x ), type ='l', ylab = 'Rho', xlab = 'Median' )
# coarse approximation slope is given by chisq median
em <- qchisq( 0.5, 1 ) # [1] 0.4549364
abline( 0, 1/em, lty = 2, col = 'gray' )
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/estimate_R.R
\name{estimate_R}
\alias{estimate_R}
\title{Estimate Covariance Matrix of Study Z-scores}
\usage{
estimate_R(Z, median = TRUE, tol = 1e-08)
}
\arguments{
\item{Z}{Matrix of z-scores, loci along rows, \code{S} studies along columns.  Missing values can be present and are appropriately ignored.}

\item{median}{If \code{TRUE}, uses \code{\link[=rho_from_median]{rho_from_median()}} to calculate covariance values from sample medians; otherwise, sample means are used.}

\item{tol}{Determinant tolerance for singularity test}
}
\value{
The \code{S}-by-\code{S} covariance matrix.
}
\description{
The default "median" estimator is expected to be more robust to outliers (present due to causal variants and linkage disequilibrium).
For completeness, the more standard "mean" estimator is also implemented, which is better when there are no outliers.
The determinant is also tested, and if its absolute value is less than \code{tol} an error is triggered, warning the user that perhaps the same study was included multiple times (as this is otherwise expected to be extremely rare).
}
\examples{

# simulate some correlated Z-scores for 3 studies and `m` loci
m <- 10000
# true correlation matrix
R <- matrix(
  c( 1.0, 0.2, 0.0,
     0.2, 1.0, 0.1,
     0.0, 0.1, 1.0 ),
  nrow = 3, ncol = 3
)
# use Cholesky decomposition to simulate via affine transform
L <- chol( R )
Z <- matrix( rnorm( m * 3 ), nrow = m, ncol = 3 ) \%*\% L

# calulate estimates
estimate_R( Z )
estimate_R( Z, median = FALSE )
# compare to naive covariance estimate, which does not assume zero mean for z-scores
cov( Z, use = 'pairwise.complete.obs' )

}
\seealso{
\code{\link[=rho_from_median]{rho_from_median()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/rho_from_median.R
\name{rho_from_median}
\alias{rho_from_median}
\title{Estimated Correlations from Sample Medians of the Correlated Standard Normal Product Distribution}
\usage{
rho_from_median(x)
}
\arguments{
\item{x}{vector of sample medians}
}
\value{
Vector of estimated correlations, extended for inflated cases.
}
\description{
This code implements estimation from the sample median of the correlation of a product of two correlated standard normal variables.
While this estimation is straightforward from the mean, using the median requires the transformation implemented here because the distribution has heavy tails, so for positive correlations the median is much smaller than the mean.
The median version is desired due to its robustness to outliers.
}
\details{
The highest correlation of \code{rho = 1} results in a median of only \code{q~0.455}.  To permit application to arbitrary data, including data that does not satisfy assumptions and is therefore inflated, the function returns \code{x/q} for elements whose absolute values of \code{x/q} exceed 1, and can therefore return values that exceed [-1, 1].
}
\examples{

# a large number of samples is required for the median to yield an accurate estimate
n <- 10000
rho <- 0.3
x <- median( rprodcor( n, rho ) )
rho_from_median( x )

}
\seealso{
\code{\link[=qprodcor]{qprodcor()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/metalcor.R
\name{metalcor}
\alias{metalcor}
\title{Meta-Analysis of Correlated Genetic Association Studies}
\usage{
metalcor(studies, median = TRUE, df = 1, tol = 1e-08)
}
\arguments{
\item{studies}{A list of \code{S} studies, each of which is a data frame with the following required columns: \code{id}, \code{chr}, \code{pos}, \code{beta}, \code{se}, \code{n}.
Column names have to match exactly.
\code{id} is used to match variants between studies (they must be unique for different variants, and be the same for the same variant).
\code{chr} and \code{pos} are used solely to sort variants after the studies have been merged.
\code{beta} and \code{se} are required to perform meta-analysis.
\code{n} is used to report locus-specific total sample sizes under missingness.}

\item{median}{If \code{TRUE} (default), estimates correlations from sample medians instead of means.
Passed to \code{\link[=estimate_R]{estimate_R()}}.}

\item{df}{Degree of freedom for calculating the p-values from the z-scores (default of 1 is best practically always).}

\item{tol}{Determinant tolerance for singularity test of R estimate}
}
\value{
A list with two named elements:
\itemize{
\item \code{assoc}: the meta-analyzed study, a tibble with columns \code{id}, \code{chr}, \code{pos}, \code{n}, \code{n_studies}, \code{beta}, \code{se}, \code{z}, and \code{p}; sorted by \code{chr} and \code{pos}.
\item \code{R}: the \code{S}-by-\code{S} estimated z-score covariance matrix
}
}
\description{
This function accepts the summary statistics from several studies, estimates their z-score correlation matrix, and performs the meta-analysis taking those correlations into account.
}
\examples{
# construct two toy studies just to run example, with minimal columns
study1 <- data.frame(
  id = paste0( 'rs', 1:5 ),
  chr = 1,
  pos = 1:5,
  n = 2000,
  beta = rnorm( 5 ),
  se = rnorm( 5 )
)
# note the second study is missing the 5th SNP, this is fine
study2 <- data.frame(
  id = paste0( 'rs', 1:4 ),
  chr = 1,
  pos = 1:4,
  n = 5000,
  beta = rnorm( 4 ),
  se = rnorm( 4 )
)

# gather the studies in a list
studies <- list( study1, study2 )
# this performs the meta-analysis modeling covariance!
out <- metalcor( studies )
# this is the meta-analyzed association table
out$assoc
# and this is the estimated study covariance matrix
out$R

}
\seealso{
\code{\link[=estimate_R]{estimate_R()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/metalcor-package.R
\docType{package}
\name{metalcor-package}
\alias{metalcor-package}
\title{Meta-Analysis of Correlated Genetic Association Studies}
\description{
\code{metalcor} generalizes the genetic association study meta-analysis software METAL to model studies with correlated statistics, which arise due to cryptic relatedness between studies.
}
\details{
This package also models the distribution of the product of correlated standard normal variables.
This is crucial for estimating correlation using the median product of z-scores, since in this case the median differs substantially from the mean.
The median provides robustness from the outliers caused by strongly associated loci.
}
\examples{
# construct two toy studies just to run example, with minimal columns
study1 <- data.frame(
  id = paste0( 'rs', 1:5 ),
  chr = 1,
  pos = 1:5,
  n = 2000,
  beta = rnorm( 5 ),
  se = rnorm( 5 )
)
# note the second study is missing the 5th SNP, this is fine
study2 <- data.frame(
  id = paste0( 'rs', 1:4 ),
  chr = 1,
  pos = 1:4,
  n = 5000,
  beta = rnorm( 4 ),
  se = rnorm( 4 )
)

library(metalcor)
# gather the studies in a list
studies <- list( study1, study2 )
# this performs the meta-analysis modeling covariance!
out <- metalcor( studies )
# this is the meta-analyzed association table
out$assoc
# and this is the estimated study covariance matrix
out$R

# if you want to focus on the Z score covariance, you can do this separately
# (metalcor does it internally too):
Z <- cbind( study1$beta / study1$se, study2$beta / study2$se )
R <- estimate_R( Z )

# lastly, let's look at the distribution of the product of correlated z scores
x <- Z[ , 1] * Z[ , 2]
# this estimates the correlation from the median product
rho_est <- rho_from_median( median( x ) )

# the underlying distribution of these products of correlated standard normal variables
# is described by the `*prodcor` family:
# simulate some data again
rho <- 0.6
n <- 100
x <- rnorm( n )
p <- runif( n )
# density function
dprodcor( x, rho )
# cumulative function
pprodcor( x, rho )
# quantile function
qprodcor( p, rho )
# random deviates
rprodcor( n, rho )

}
\seealso{
Useful links:
\itemize{
  \item \url{https://github.com/OchoaLab/metalcor}
  \item Report bugs at \url{https://github.com/OchoaLab/metalcor/issues}
}

}
\author{
\strong{Maintainer}: Alejandro Ochoa \email{alejandro.ochoa@duke.edu} (\href{https://orcid.org/0000-0003-4928-3403}{ORCID})

Authors:
\itemize{
  \item Alejandro Ochoa \email{alejandro.ochoa@duke.edu} (\href{https://orcid.org/0000-0003-4928-3403}{ORCID})
  \item Tiffany Tu \email{tiffany.tu@duke.edu} (\href{https://orcid.org/0000-0002-9357-6660}{ORCID})
}

}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/dprodcor.R, R/pprodcor.R, R/qprodcor.R,
%   R/rprodcor.R
\name{prodcor}
\alias{prodcor}
\alias{dprodcor}
\alias{pprodcor}
\alias{qprodcor}
\alias{rprodcor}
\title{The Correlated Standard Normal Product Distribution}
\usage{
dprodcor(x, rho)

pprodcor(x, rho, eps = 1e-08)

qprodcor(p, rho)

rprodcor(n, rho)
}
\arguments{
\item{x}{Vector of quantiles.}

\item{rho}{Correlation parameter, must be a scalar in [-1, 1].}

\item{eps}{Near zero value to use for integrating around the divergence at \code{x=0}.}

\item{p}{Vector of probabilities.}

\item{n}{Number of observations.  If \code{length(n) > 1}, the length is taken to be the number required.}
}
\value{
\code{dprodcor} gives the density, \code{pprodcor} the cumulative, and \code{qprodcor} the quantile function.  \code{rprodcor} generates random deviates.  The length of the result is determined by \code{n} for \code{rnorm}, and it is the length of \code{x} or \code{p} for the other functions.
}
\description{
Density, cumulative, quantile, and random generation for the product of two correlated standard normal variables with correlation parameter \code{rho}.
}
\details{
\code{pprodcor} does not have a closed form, so it is calculated by numerical integration of \code{dprodcor}.
Furthermore, \code{dprodcor(0)} is infinite, so in order for numerical integration to succeed, we exclude the window \code{c(-eps, eps)} for arguments near zero.  \code{eps} is the initial value, but if failure is still encountered, \code{eps} is incremented by factors of 10 until successful.  (For positive arguments integration from above is used instead, subtracted from 1.)
\code{qprodcor} also does not have a closed form, so it is calculated using a root finder on \code{pprodcor}, which makes it very slow.
}
\examples{
n <- 10
x <- rnorm( n )
p <- runif( n )
rho <- 0.8
dprodcor( x, rho )
pprodcor( x, rho )
qprodcor( p, rho )
rprodcor( n, rho )

}
\references{
Nadarajah, Saralees, and Tibor K. Pogány. “On the Distribution of the Product of Correlated Normal Random Variables.” Comptes Rendus Mathematique 354, no. 2 (2016): 201–4. \doi{10.1016/j.crma.2015.10.019}.

Gaunt, Robert E. “The Basic Distributional Theory for the Product of Zero Mean Correlated Normal Random Variables.” Statistica Neerlandica 76, no. 4 (2022): 450–70. \doi{10.1111/stan.12267}.
}
